/*
 * Copyright (c) 2013 - 2016 TDP Ltd All Rights Reserved.
 * TDP Ltd grants permission, free of charge, to any person obtaining copies
 * of this software and its associated documentation files (the "Software"),
 * to deal in the Software without restriction, including to use, copy, adapt,
 * publish, distribute, display, perform, sublicense, and sell copies of the
 * Software, subject to the following condition: You must include the above
 * copyright notice and this permission notice in all full or partial copies
 * of the Software.
 * TDP LTD PROVIDES THE SOFTWARE "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
 * INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, AND NON-INFRINGMENT. TDP LTD, THE AUTHORS OF THE SOFTWARE,
 * AND THE OWNERS OF COPYRIGHT IN THE SOFTWARE ARE NOT LIABLE FOR ANY CLAIM, DAMAGES,
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT, OR OTHERWISE, ARISING
 * FROM, OUT OF, OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package cz.tdp.kshield.springsecurity2;


import java.io.IOException;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.security.ui.FilterChainOrder;
import org.springframework.security.ui.preauth.AbstractPreAuthenticatedProcessingFilter;

import cz.tdp.kshield.client.UserInfo;
import cz.tdp.kshield.integration.AuthenticationService;
import cz.tdp.kshield.integration.KShieldContext;

/**
 * @deprecated Spring Security 2.x support will be removed > 4.4.x versions of SDK
 *             <p><b>This is central class in springsecurity2 package.</b>
 */
@Deprecated
public class KShieldPreAuthenticationFilter extends AbstractPreAuthenticatedProcessingFilter
{
  /**
   * Suffix used in fake use password
   */
  public static final String KSHIELD_PASSWD_SUFFIX = "\034\035\036\037kshield";
  
  @Override
  public void doFilterHttp(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain) throws IOException, ServletException {
    try {
      super.doFilterHttp(request, response, filterChain);
    }
    finally {
      KShieldContext.closeKShieldSession();
    }
  }
  
  @Override
  protected Object getPreAuthenticatedCredentials(HttpServletRequest request) {
    return request.getRemoteAddr() + KSHIELD_PASSWD_SUFFIX;
  }
  
  @Override
  protected Object getPreAuthenticatedPrincipal(HttpServletRequest request) {
    final UserInfo info = authenticationService.createUserInfo(request.getRemoteAddr());
    
    if (info != null) {
      return getPrincipal(info);
    }
    
    return null;
  }
  
  @Override
  public int getOrder() {
    return FilterChainOrder.PRE_AUTH_FILTER;
  }
  
  /**
   * @param userInfo UserInfo class returned by KeyShield SSO Server client
   * @return username retrieved from UserInfo
   */
  protected String getPrincipal(UserInfo userInfo) {
    return userInfo.getUsername();
  }
  
  private AuthenticationService authenticationService;
  
  public void setAuthenticationService(AuthenticationService authService) {
    this.authenticationService = authService;
  }
  
  protected final Log log = LogFactory.getLog(getClass());
}
